#' Volatility-adjusted log returns of the two Banks Citigroup and Bank of
#' America.
#' 
#' A dataset containing the volatility-adjusted log returns of two Banks in the
#' years 2004-2012.
#' 
#' 
#' @name Banks
#' @docType data
#' @format A list with 9 entries containing the Banks log returns divided by
#' years.
#' @source Yahoo-Finance.
NULL


#' Volatility-adjusted log returns of the two Cryptocurrencies Bitcoin and
#' Litecoin.
#' 
#' A dataset containing the volatility-adjusted log returns of two
#' Cryptocurrencies in the years 2015-2018.
#' 
#' 
#' @name CryptoCurrencies
#' @docType data
#' @format A list with 4 entries containing the Cryptocurrencies log returns
#' divided by years.
#' @source CoinMetrics. \url{https://coinmetrics.io/}
NULL


#' Log returns of european stock indices
#' 
#' A dataset containing the log returns of two european stock indices in the
#' year 1998.
#' 
#' 
#' @name IndexReturns2D
#' @docType data
#' @format A matrix with 100 rows and 2 columns
#' @source The raw data are part of the R datasets and were kindly provided by
#' Erste Bank AG, Vienna, Austria.
NULL


#' Log returns of european stock indices
#' 
#' A dataset containing the log returns of three european stock indices in the
#' year 1998.
#' 
#' 
#' @name IndexReturns3D
#' @docType data
#' @format A matrix with 200 rows and 3 columns
#' @source The raw data are part of the R datasets and were kindly provided by
#' Erste Bank AG, Vienna, Austria.
NULL



